-- employee table
DROP TABLE "SYSTEM"."EMPLOYEE";
CREATE TABLE "SYSTEM"."EMPLOYEE" 
   (  "FIRST_NAME" VARCHAR2(20 BYTE), 
      "LAST_NAME" VARCHAR2(20 BYTE),
      "EMP_NO" NUMBER, 
      "JOIN_DATE" DATE
   ) 
TABLESPACE "SYSTEM" ;

-- t_type
create or replace
TYPE t_type AS OBJECT (
  first_name varchar2(20),
  last_name varchar2(20),
  emp_no number,
  join_date date
);

-- tb_t_type
create or replace
type tb_t_type
as varray (1000000) of t_type;

-- add_employees stored proc
create or replace
procedure add_employees (emparray in tb_t_type) as

begin
  forall i in emparray.first .. emparray.last
    insert into EMPLOYEE(first_name,last_name,emp_no,join_date)
    values(emparray(i).first_name,emparray(i).last_name,emparray(i).emp_no,emparray(i).join_date);
end add_employees;
